<script lang="ts">
    import { onMount } from 'svelte';
    import { fade, fly } from 'svelte/transition';
    import { backOut } from 'svelte/easing';

    enum ToastType {
        success = 'success',
        failure = 'failure'
    }

    interface Toast {
        _id: number;
        msg: string;
        type: ToastType;
    }

    let toasts: Toast[] = [];
    let retainMs: number = 3500;

    let toastId: number = 0;
    export const pushToast = (msg, type): void => {
        toasts = [...toasts, {
            _id : ++toastId,
            msg,
            type
        }];
        setTimeout(() => {
            unshiftToast();
        }, retainMs);
    };

    const unshiftToast = (): void => {
        toasts = toasts.filter((a, i) => i > 0);
    };

    onMount(() => {
        window['pushToast'] = pushToast;
    });
</script>

<style>
    .toast-wrapper {
        position: fixed;
        left: 0;
        right: 0;
        bottom: 0;
        text-align: center;
        z-index: 9999;
    }
    .toast-item {
        border-radius: 4px;
        padding: 12px 10px;
        margin: 10px auto;
        max-width: 400px;
    }
</style>

<div class="toast-wrapper">
    {#each toasts as toast (toast._id)}
        <div class="toast-item notification" class:is-success={toast.type === ToastType.success} class:is-danger={toast.type === ToastType.failure} in:fly="{{delay: 0, duration: 300, x: 0, y: 50, opacity: 0.1, easing: backOut}}" out:fade={{duration:500, opacity: 0}}>
            {toast.msg}
        </div>
    {/each}
</div>
